poller/urls.py
#
# -*- coding: utf-8 -*- vim:fileencoding=utf-8:

# Copyright (C) 2010-2014 GRNET S.A.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
from django.conf.urls import url

from poller import views
urlpatterns = [
    #'poller.views',
    url('^$', views.main),
    # 1st call to get all existing messages
    url('^message/existing/(?P<peer_id>[\w\-]+)/$', views.message_existing, name='fetch-existing'),
    # update - get new messages
    url('^message/updates/(?P<peer_id>[\w\-]+)/$', views.message_updates, name='fetch-updates'),
    url('^message/updates/(?P<peer_id>[\w\-]+)/(?P<last_id>[\w\-]+)$', views.message_updates, name='fetch-updates')
]

flowspec/models.py
# -*- coding: utf-8 -*- vim:fileencoding=utf-8:
# vim: tabstop=4:shiftwidth=4:softtabstop=4:expandtab

# Copyright (C) 2010-2014 GRNET S.A.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

from django.db import models
from django.conf import settings
from django.contrib.auth.models import User
from django.contrib.sites.models import Site
from django.utils.translation import ugettext_lazy as _
from django.urls import reverse
from flowspec.tasks import *

from flowspec.helpers import send_new_mail, get_peer_techc_mails
from utils import proxy as PR
from ipaddress import *
from ipaddress import ip_network
import datetime
import json
from peers.models import PeerRange, Peer

from flowspec.junos import create_junos_name
from utils.flowspec_utils import map__ip_proto__for__ip_version__from_flowspec

#import flowspec.iprange_match
from flowspec.iprange_match import find_matching_peer_by_ipprefix__simple

from utils.randomizer import id_generator as id_gen

import flowspec.logging_utils
logger = flowspec.logging_utils.logger_init_default(__name__, "flowspec_models.log", False)


FRAGMENT_CODES = (
    ("dont-fragment", "Don't fragment"),
    ("first-fragment", "First fragment"),
    ("is-fragment", "Is fragment"),
    ("last-fragment", "Last fragment"),
    ("not-a-fragment", "Not a fragment")
)

THEN_CHOICES = (
    ("accept", "Accept"),
    ("discard", "Discard"),
    ("community", "Community"),
    ("next-term", "Next term"),
    ("routing-instance", "Routing Instance"),
    ("rate-limit", "Rate limit"),
    ("sample", "Sample")
)

MATCH_PROTOCOL = (
    ("ah", "ah"),
    ("egp", "egp"),
    ("esp", "esp"),
    ("gre", "gre"),
    ("icmp", "icmp"),
    ("icmp6", "icmp6"),
    ("igmp", "igmp"),
    ("ipip", "ipip"),
    ("ospf", "ospf"),
    ("pim", "pim"),
    ("rsvp", "rsvp"),
    ("sctp", "sctp"),
    ("tcp", "tcp"),
    ("udp", "udp"),
)

ROUTE_STATES = (
    ("ACTIVE", "ACTIVE"),
    ("ERROR", "ERROR"),
    ("EXPIRED", "EXPIRED"),
    ("PENDING", "PENDING"),
    ("PENDING_TODELETE", "PENDING_TODELETE"),
    ("OUTOFSYNC", "OUTOFSYNC"),
    ("INACTIVE", "INACTIVE"),
    ("INACTIVE_TODELETE", "INACTIVE_TODELETE"),
    ("ADMININACTIVE", "ADMININACTIVE"),
)


#def days_offset(): return datetime.date.today() + datetime.timedelta(days = settings.EXPIRATION_DAYS_OFFSET)
def days_offset(): return datetime.date.today() + datetime.timedelta(days = settings.EXPIRATION_DAYS_OFFSET-1)

class MatchPort(models.Model):
    port = models.CharField(max_length=24, unique=True)
    def __unicode__(self):
        return self.port
    def __str__(self):
        return self.__unicode__()
    class Meta:
        db_table = u'match_port'

class MatchDscp(models.Model):
    dscp = models.CharField(max_length=24)
    def __unicode__(self):
        return self.dscp
    def __str__(self):
        return self.__unicode__()
    class Meta:
        db_table = u'match_dscp'

class MatchProtocol(models.Model):
    protocol = models.CharField(max_length=24, unique=True)
    def __unicode__(self):
        return self.protocol
    def __str__(self):
        return self.__unicode__()
    def __eq__(self, b):
        if self.protocol == b.protocol:
            return True
        else:
            return super().__eq__(b)
    class Meta:
        db_table = u'match_protocol'

class FragmentType(models.Model):
    fragmenttype = models.CharField(max_length=20, choices=FRAGMENT_CODES, verbose_name="Fragment Type")

    def __unicode__(self):
        return "%s" %(self.fragmenttype)

    def __str__(self):
        return self.__unicode__()


class ThenAction(models.Model):
    action = models.CharField(max_length=60, choices=THEN_CHOICES, verbose_name="Action")
    action_value = models.CharField(max_length=255, blank=True, null=True, verbose_name="Action Value")

    def __unicode__(self):
        ret = "%s:%s" %(self.action, self.action_value)
        return ret.rstrip(":")

    def __str__(self):
        return self.__unicode__()

    class Meta:
        db_table = u'then_action'
        ordering = ['action', 'action_value']
        unique_together = ("action", "action_value")


class Route(models.Model):
    name = models.SlugField(max_length=128, verbose_name=_("Name"))
    applier = models.ForeignKey(User, blank=True, null=True, on_delete=models.CASCADE)
    source = models.CharField(max_length=45+4, help_text=_("Network address. Use address/CIDR notation"), verbose_name=_("Source Address"))
    sourceport = models.TextField(blank=True, null=True, verbose_name=_("Source Port"))
    destination = models.CharField(max_length=45+4, help_text=_("Network address. Use address/CIDR notation"), verbose_name=_("Destination Address"))
    destinationport = models.TextField(blank=True, null=True, verbose_name=_("Destination Port"))
    port = models.TextField(blank=True, null=True, verbose_name=_("Port"))
    dscp = models.ManyToManyField(MatchDscp, blank=True, verbose_name="DSCP")
    fragmenttype = models.ManyToManyField(FragmentType, blank=True, verbose_name="Fragment Type")
    icmpcode = models.CharField(max_length=32, blank=True, null=True, verbose_name="ICMP Code")
    icmptype = models.CharField(max_length=32, blank=True, null=True, verbose_name="ICMP Type")
    packetlength = models.IntegerField(blank=True, null=True, verbose_name="Packet Length")
    protocol = models.ManyToManyField(MatchProtocol, blank=True, verbose_name=_("Protocol"))
    tcpflag = models.CharField(max_length=128, blank=True, null=True, verbose_name="TCP flag")
    then = models.ManyToManyField(ThenAction, verbose_name=_("Then"))
    filed = models.DateTimeField(auto_now_add=True)
    last_updated = models.DateTimeField(auto_now=True)
    status = models.CharField(max_length=20, choices=ROUTE_STATES, blank=True, null=True, verbose_name=_("Status"), default="PENDING")
#    is_online = models.BooleanField(default=False)
#    is_active = models.BooleanField(default=False)
    #expires = models.DateField(default=days_offset, verbose_name=_("Expires"))
    expires = models.DateField(default=days_offset, verbose_name=_("Expires"))
    response = models.CharField(max_length=512, blank=True, null=True, verbose_name=_("Response"))
    comments = models.TextField(null=True, blank=True, verbose_name=_("Comments"))
    requesters_address = models.CharField(max_length=255, blank=True, null=True)

    @property
    def name_visible(self):
        l = len(settings.RULE_NAME_PREFIX)
        prefix = self.name[0:l]
        if prefix==settings.RULE_NAME_PREFIX:
          return self.name[l:len(self.name)]
        else:
          return self.name

    @property
    def applier_username(self):
        if self.applier:
            return self.applier.username
        else:
            return None

    @property
    def applier_username_nice(self):
        if self.applier:
            if self.applier.first_name or self.applier.last_name:
                fn = self.applier.first_name if self.applier.first_name else ""
                ln = self.applier.last_name if self.applier.last_name else ""
                ret = "{0} {1}".format(fn, ln).strip()
            elif self.applier.email:
                ret = self.applier.email
            else:
                ret = self.applier.username
            return ret
        else:
            return None

    def ip_version(self):
            
        route_obj = self

        source_ip_version = 4
        destination_ip_version = 4
        try:
          source_ip_version = ip_network(route_obj.source, strict=False).version
          destination_ip_version = ip_network(route_obj.destination, strict=False).version
        except Exception as e:
          logger.error("model::route::ip_version(): exception in trying to determine ip_version: "+str(e))
        pass

        #logger.debug("model::route::ip_version(): source_ip_version="+str(source_ip_version)+" destination_ip_version="+str(destination_ip_version))
        if source_ip_version != destination_ip_version:
          logger.error("model::route::ip_version(): source_ip_version="+str(source_ip_version)+" != destination_ip_version="+str(destination_ip_version))
          return -1

        ip_version = source_ip_version and destination_ip_version
        #logger.debug("model::route::ip_version(): ip_version="+str(ip_version))

        return ip_version
    
    def is_ipv4(self):
        return self.ip_version()==4


    def __unicode__(self):
        return self.name

    def __str__(self):
        return self.__unicode__()

    class Meta:
        db_table = u'route'
        verbose_name = "Rule"
        verbose_name_plural = "Rules"

    def save(self, *args, **kwargs):
        if not self.pk:
            suff = id_gen()
            #self.name = "%s_%s" % (self.name, suff)
            self.name = "%s%s_%s" % (settings.RULE_NAME_PREFIX, self.name, suff)
        super(Route, self).save(*args, **kwargs)

    def clean(self, *args, **kwargs):
        from django.core.exceptions import ValidationError
        if self.destination:
            try:
                address = ip_network(self.destination, strict=False)
                self.destination = address.exploded
            except Exception:
                raise ValidationError(_('Invalid network address format at Destination Field'))
        if self.source:
            try:
                address = ip_network(self.source, strict=False)

templates/add_port.html
{% load i18n %}
{% load widget_tweaks %}



    <form id="add_port_form" method="POST"  class="form-horizontal">
    {% csrf_token %}
		<div class="form-group {% if form.port.errors %} has-error {% endif %}">
		<div class="col-md-5">
		            {% render_field form.port class+="form-control" placeholder="Port(s), eg. 80,1000-1100,8088" %}
		            {% if form.port.errors %} <span class="help-block"> {{ form.port.errors|join:", " }} </span>
		            {% endif %}
		        </div>
		        		<div class="col-md-4">
		        		<button class="btn-warning btn btn-md btn-outline" id="canceladdportbtn" type="button">{% trans "Cancel" %}</button>
		        		<button class="btn-success btn btn-md btn-outline" id="addportbtn" type="button">{% trans "Add" %}</button>
		        </div>
		</div>
    </form>
<script>
$(document).ready( function(){
	$('#addportbtn').click(function(){
		$.ajax({
		url:"{% url 'add-port' %}", 
		data:$("#add_port_form").serialize(),
		type: "POST",
		cache: false,
		success:function(data){
				try {
					value = data.value;
					text = data.text;
					if (typeof value === 'undefined' && typeof text === 'undefined'){
						$('#port_diag').html(data);	
					}
					else{
						$('#id_port').append($("<option></option>").attr("value",value).text(text));
						$('#id_destinationport').append($("<option></option>").attr("value",value).text(text));
						$('#id_sourceport').append($("<option></option>").attr("value",value).text(text));
						$('#port_diag').html('');
						$('#addnewport').hide();
						$(".new_port").show();
						reArrangeSelect2("id_sourceport");
						reArrangeSelect2("id_destinationport");
						reArrangeSelect2("id_port");
					}
				}
				catch (exception) {
					$('#port_diag').html(data);
				}					
			}
			});
	});
	$('#canceladdportbtn').click(function(){
		$('#port_diag').html('');
		$('#addnewport').hide();
		$(".new_port").show();
	});
	
		function reArrangeSelect2(elementId) {
	   $("#"+elementId).html($("#"+elementId+" option").sort(function(a, b) {
			return parseInt(a.text) == parseInt(b.text) ? 0 : parseInt(a.text) < parseInt(b.text) ? -1 : 1
		}));
	}
});
			</script>

templates/add_rate_limit.html
<form id="add_rl_form" method="POST">
	{% csrf_token %}
<table>
<input type="hidden" id="id_action" name="action" value="rate-limit"/>
<tr><th>Value</th><td>{{ form.action_value }}Kbps<span class="error" id='rl_error'>{{ form.action_value.errors|join:", " }}</span></td></tr>
<tr class="help"><td></td><td>Value should be >50Kbps</td></tr>
</table>
</form>

templates/base.html
{% load i18n %}
{% load static %}

<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{{ settings.BRANDING.name }} {{ settings.BRANDING.product_name_short|default:'FoD' }} :: {% block title %}{% endblock %}</title>
	<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
	<META HTTP-EQUIV="expires" CONTENT="Wed, 26 Feb 1997 08:21:57 GMT">
	<link REL="SHORTCUT ICON" HREF="{% get_static_prefix %}/{{ settings.BRANDING.favicon }}">
    <!-- Core CSS - Include with every page -->
    <link href="{% static 'b3theme/css/bootstrap.min.css' %}" rel="stylesheet">
    <link href="{% static 'b3theme/font-awesome/css/font-awesome.css' %}" rel="stylesheet">
    <link href="{% static 'css/custom.css' %}" rel="stylesheet">
    <script src="{% static 'js/validation.js' %}" rel="stylesheet"></script>

    {% block extrahead %}{% endblock %}

    <!-- SB Admin CSS - Include with every page -->
    <link href="{% static 'b3theme/css/sb-admin.css' %}" rel="stylesheet">
    {% block extraheadbottom %}{% endblock %}
</head>

<body>

    <div id="wrapper">
        <nav class="navbar navbar-default navbar-static-top" role="navigation" >
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".sidebar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a class="navbar-brand" href="{% url 'dashboard' %}"><img src="{% get_static_prefix %}/{{ settings.BRANDING.logo }}">&nbsp;</a>
            </div>
            <!-- /.navbar-header -->

            <ul class="nav navbar-top-links navbar-right">
            	<li class="dropdown">
		           <a href="#" class="dropdown-toggle" data-bs-toggle="dropdown">{% trans "Documentation" %}<b class="caret"> </b></a>

				            <ul class="dropdown-menu">
				                <li>
					            <a class="unknown" target="_blank" href="/static/site/index.html">Documentation Main</a>
				            </li>
				            </ul>
               </li>
            	<li class="dropdown">
				            <a href="#" class="dropdown-toggle" data-bs-toggle="dropdown">{% trans "Language" %}: {% for lang in settings.LANGUAGES %}{% ifequal settings.LANGUAGE_CODE lang.0 %}{% trans lang.1 %}{% endifequal %}{% endfor %}<b class="caret"></b></a>
				            <ul class="dropdown-menu">
						    <form action="/set_language/" method="post" style="display:inline;" id="langform">
												{% csrf_token %}
												<input name="next" type="hidden" value="{{ next }}" />
												<input id="langsel" name="language" type="hidden" value="" />
											</form>
				            	{% for lang in settings.LANGUAGES %}
				                <li>
				                    <a class="select_lang" href="#" onclick="setlang('{{ lang.0 }}'); return false;" title="{{lang.1}}">{% trans lang.1 %}{% ifequal settings.LANGUAGE_CODE lang.0 %}  <i class="icon-ok"></i>{% endifequal %}</a>
				                </li>
				              {% endfor %}
				            </ul>
				        </li>
                <!-- /.dropdown -->


				 {% if user.is_authenticated %}
                <li class="dropdown">
                    <a class="dropdown-toggle" data-bs-toggle="dropdown" href="#">
                        <i class="fa fa-user fa-fw" id="user_icon_id"></i>  <i class="fa fa-caret-down"></i>
                    </a>
                    <ul class="dropdown-menu dropdown-user" role="menu" >
                    	<li role="presentation" class="dropdown-header">{{user}}</li>
                    	<li class="divider"></li>
                    {% if user.userprofile.peers.all %}
				        <li>
				            <a href="{% url 'user-profile' %}"><i class="fa fa-user fa-fw" id="my_profile_id"></i>{% trans "My profile" %}</a>
				        </li>
				    {% endif %}
				    	{% if user.is_superuser %}
						<li class="divider"></li>
                        <li><a href="{% url 'admin:index' %}"><i class="fa fa-cogs" id="user_icon_admin_id"></i> {% trans "Admin" %}</a>
                        </li>
						{% endif %}
                        <li class="divider"></li>
                        <li><a href="{% url 'logout' %}"><i class="fa fa-sign-out fa-fw" id="log_out_id"></i> {% trans "Logout" %}</a>
                        </li>

                    </ul>
                    <!-- /.dropdown-user -->
                </li>
                {% else %}
					{% if settings.SHIB_LOGIN_ENABLED %}
				        <li><a href="{% url 'login' %}">{% trans "Shibboleth Login" %}</a></li>
					{% else %}
				        <li><a href="{% url 'altlogin' %}">{% trans "Local Login" %}</a></li>
				        {% endif %}
				        {% endif %}
                <!-- /.dropdown -->
            </ul>
            <!-- /.navbar-top-links -->

        </nav>
        <!-- /.navbar-static-top -->
		{% block sidenav %}
        <nav class="navbar-default navbar-static-side" role="navigation">
        	{% if user.is_authenticated %}
            <div class="sidebar-collapse">
                <ul class="nav" id="side-menu">
                    <li>
                        <a href="{% url 'dashboard' %}" id="navigation_dashboard_id"><i class="fa fa-dashboard fa-fw"></i> {% trans "Dashboard" %}</a>
                    </li>
                    <li>
                        <a href="{% url 'group-routes' %}" id="navigation_rules_id"><i class="fa fa-shield fa-fw"></i> {% trans "Rules" %}</a>
                    </li>
                    <li>
                        <a href="{% url 'add-route' %}" id="navigation_add_rule_id"><i class="fa fa-plus-circle fa-fw"></i> {% trans "Add Rule" %}</a>
                    </li>
                    {% if perms.accounts.overview %}<li>
                            <a href="{% url 'overview' %}" id="navigation_overview_id"><i class="fa fa-desktop fa-fw"></i> {% trans "Overview" %}</a>
                        </li>{% endif %}
                    {% if user.is_superuser %}
                        <li><a href="{% url 'admin:index' %}" id="navigation_admin_id"><i class="fa fa-cogs fa-fw"></i> {% trans "Admin" %}</a>
                        </li>
						{% endif %}
                    {% if user.userprofile.peers.all %}
				        <li>
				            <a href="{% url 'user-profile' %}" id="navigation_user_profile_id"><i class="fa fa-user fa-fw"></i> {% trans "My profile" %}</a>
				        </li>
				    {% endif %}
                </ul>
                <!-- /#side-menu -->
            </div>
            {% endif %}
            <!-- /.sidebar-collapse -->
        </nav>
        <!-- /.navbar-static-side -->
		{% endblock %}
        <div id="page-wrapper">

        	{% if messages %}
        	        	<div class="row">
        		<div class="lg-col-12">
				<div id="messages">
				{% for message in messages %}
					<div {% if message.tags %} class="alert alert-{{ message.tags }} alert-dismissable"{% endif %}>
					<button type="button" class="close" data-dismiss="alert" aria-hidden="true">&times;</button>
					{{ message }}</span><br />
				{% endfor %}
				</div>
								</div>
			</div>
		{% endif %}

        	{% block contentplaceholder %}
        	{% endblock %}
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
	{% block footerblock %}
				{% include "footer.html" %}
			{% endblock %}
    <!-- Core Scripts - Include with every page -->
    <!--<script src="{% static 'js/jquery/jquery-3.6.0.min.js' %}"></script>-->
    <script src="{% static 'js/jquery/jquery.min.js' %}"></script>
    <script src="{% static 'js/jquery.add/jquery_csrf_protect.js' %}" type="text/javascript"></script>
    <link rel="stylesheet" href="{% static 'css/jquery-ui.min.css' %}" />
    <script type="text/javascript" src="{% static 'js/jquery-ui/jquery-ui.min.js' %}"></script>
    <script src="{% static 'js/popper/popper.min.js' %}"></script>
    <script src="{% static 'b3theme/js/bootstrap.min.js' %}"></script>
    <script src="{% static 'b3theme/js/plugins/metisMenu/jquery.metisMenu.js' %}"></script>
    <script type="text/javascript" src="{% static 'js/jquery.add/jquery.cookie.js' %}"></script>

	{% block pagejs %}{% endblock %}

    <!-- SB Admin Scripts - Include with every page -->
    <script src="{% static 'b3theme/js/sb-admin.js' %}"></script>
    <!-- Page-Level Scripts  - Use for reference -->
    {% block pagejsbottom %}{% endblock %}
    <script type="text/javascript">

  	function setlang(lang){
		$("#langsel").val(lang);
		$("#langform").submit();
	}

	$(document).ready(function() {
  $.ajaxSetup({ cache: false });
});

	</script>

</body>

</html>

templates/error.html
{% extends "base.html" %}
{% load widget_tweaks %}

{% load i18n %}
   {% block sidenav %}{% endblock %}
   {% block extraheadbottom %}
<style>
	@media (min-width: 768px) {
		#page-wrapper {
		    border-left: none;
		    margin: 0;
		}
}
</style>
{% endblock %}

{% block title %}{% if error %}{% if inactive %}{% trans "Activation Pending" %}{% else %}{% trans "Error" %}{% endif %}{% endif %}{% endblock %}

{% block pagejsbottom %}
	<script type="text/javascript">
	$(document).ready(function(){
		$("#ttip").tooltip();
		});
	</script>
{% endblock %}

{% block contentplaceholder %}
       <div class="container">
       <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">{% if error %}{% if inactive %}{% trans "Activation Pending" %}{% else %}{% trans "Error" %}{% endif %}{% endif %}</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>

            <div class="row">
                <div class="col-lg-12">
                	<div class="panel  {% if error %}{% if inactive %}panel-primary{% else %}panel-danger{% endif %}{% endif %}">
                        <div class="panel-heading">
                            <i class="fa fa-info-circle"></i> {% if error %}{% if inactive %}{% trans "Activation Pending" %}{% else %}{% trans "Error" %}{% endif %}{% endif %}
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                        						<div class="alert {% if missing_attributes %}alert-danger{% else %}alert-info{% endif %}">
					{% if missing_attributes %}
						<p>{% trans "One or more required shibboleth attributes were not released towards this service" %}</p>
						{% endif %}
						<p>{% autoescape off %}{{error}}{% endautoescape %}</p>
						{% if missing_attributes %}
						<p>
						{% trans "Required shibboleth attributes" %}:<br>
						<ul>
              {% if required_attributes_attribute_info__list %}
                {% for attribute_info in required_attributes_attribute_info__list %}
            <li>{{ attribute_info }}</li>
                {% endfor %}
              {% else %}
						<li>eduPersonPrincipalName</li>
						<li>mail</li>
						<li>eduPersonEntitlement</li>
              {% endif %}
						</ul>
						{% trans "Optional" %}:
						<ul>
              {% if optional_attributes_attribute_info__list %}
                {% for attribute_info in optional_attributes_attribute_info__list %}
            <li>{{ attribute_info }}</li>
                {% endfor %}
              {% else %}
						<li>givenName</li>
						<li>sn</li>
              {% endif %}
						</ul>
						</p>
						{% endif %}
					</div>
                        	</div>
                        </div>
                       </div>
                      </div>
                     </div>

	{% endblock %}

templates/footer.html
{% load i18n %}
{% load staticfiles %}
	<footer class="footer">
      <div id="footcontainer" class="container">
        {% if user.is_authenticated %}
	<p>{% trans "If you have any questions or need help, contact" %}&nbsp;{{ settings.BRANDING.contact_support | safe }}</p>
	{% endif %}
	<!--<div style="padding-top: 10px;"><a href="https://code.grnet.gr/projects/flowspy">Version: <strong>{{ settings.SW_VERSION }}</strong></a>  -->
	<div style="padding-top: 10px;"><a href="https://github.com/GEANT/FOD">Version: <strong>{{ settings.SW_VERSION }}</strong></a> - 
        {% trans "Designed and developed in GÉANT5-1 WP8-T3; Originally designed and developed by GRNET NOC" %}
</a>
	</div>
        <div style="padding-top: 10px;">

        </div>
      </div>
    </footer>

templates/poll.html
<div id="inbox" >
	{% for message in messages %}
          {% include "poll_message.html" %}
	{% endfor %}
	<input type="hidden" name="hid_mid" id="hid_mid" value=''/>
</div>

templates/poll_message.html
<div class="message" id="m{{ message.id }}">{{ message.body }}</div>

templates/polldash.html
<div  >
	<ul class="chat" id="inbox">
	{% for message in messages %}
          {% include "poll_message.html" %}
	{% endfor %}
	</ul>
	<input type="hidden" name="hid_mid" id="hid_mid" value=''/>
</div>